您的位置:首页 > 其它

Leetcode算法学习日志-338 Counting Bits

2017-09-02 22:04 429 查看

LeetCode 338 Counting Bits

题目原文

Given a non negative integer number num. For every numbers
i in the range 0 ≤ i ≤ num calculate the number of 1's in their binary representation and return them as an array.

Example:

For
num = 5
you should return
[0,1,1,2,1,2]
.

Follow up:

It is very easy to come up with a solution with run time
O(n*sizeof(integer)). But can you do it in linear time O(n) /possibly in a single pass?
Space complexity should be O(n).
Can you do it like a boss? Do it without using any builtin function like
__builtin_popcount in c++ or in any other language.

题意分析

由于题目明确说明复杂度为O(n),所以不能对数字的二进制进行直接计算,应该寻求数和前一个数1的个数的关系,经过一次遍历得到结果,这种往往采用动态规划方法。

解法分析

此题虽然不是最优化问题,但仍然可以采用动态规划的方法,写出数的二进制表示中1的个数与前面已经求出的个数的关系,比如5,二进制为101,其1的个数C(5)=C(4)+C(5-4),C(4)一的个数为1,且任何2的次方其二进制的1的个数均为1,所以C(n)=1+C(n-2^j),其中j为使2^j小于等于n的最大整数,由递归式可以看到这是一个简单的自底向上的动态规划问题,C++代码如下:

class Solution {
public:
vector<int> countBits(int num) {
vector<int> myCount(num+1,0);
int i,j=0;
for(i=1;i<=num;i++){
if((int)pow(double(2),j+1)==i)
j++;
myCount[i]=1+myCount[i-(int)pow(double(2),j)];
}
return myCount;
}
};上述算法复杂度为O(n),符合要求。
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: